package org.chess.nattable.chrtspecification.manager.axis;

import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.papyrus.uml.nattable.manager.axis.AbstractStereotypedElementUMLSynchronizedOnFeatureAxisManager;
import org.eclipse.papyrus.uml.service.types.element.UMLElementTypes;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.util.UMLUtil;
import org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.CHRtSpecification;
import org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTComponentModelPackage;

public class CHRtSpecificationAxisManager extends AbstractStereotypedElementUMLSynchronizedOnFeatureAxisManager<CHRtSpecification> {

	@Override
	public boolean canCreateAxisElement(String elementId) {
		return ((IHintedType) UMLElementTypes.COMMENT).getId().equals(elementId);
	}
	
	
	@Override
	protected boolean isInstanceOfRequiredStereotypeApplication(Object object) {
		return object instanceof CHRtSpecification;
	}

	
	@Override
	protected CHRtSpecification getStereotypeApplication(Element element) {
		return UMLUtil.getStereotypeApplication(element, CHRtSpecification.class);
	}

	
	@Override
	protected Element getStereotypeBaseElement(final CHRtSpecification stereotypeApplication) {
		return stereotypeApplication.getBase_Comment();
	}

	
	@Override
	protected boolean isAllowedAsBaseElement(Element element) {
		return element instanceof Comment;
	}

	
	@Override
	protected String getStereotypeApplicationBasePropertyName() {
		return RTComponentModelPackage.eINSTANCE.getCHRtSpecification_Base_Comment().getName();
	}
}
