/*****************************************************************************
 * Copyright (c) 2011 - 2014 University of Padova, Intecs
 *
 *    
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 *
 *****************************************************************************/
package org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.RTDataTypesFactory
 * @model kind="package"
 * @generated
 */
public interface RTDataTypesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "RTDataTypes";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///CHESS/Predictability/RTComponentModel/RTDataTypes.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "CHESS.Predictability.RTComponentModel.RTDataTypes";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RTDataTypesPackage eINSTANCE = org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_SporadicPatternImpl <em>CH Sporadic Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_SporadicPatternImpl
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getCH_SporadicPattern()
	 * @generated
	 */
	int CH_SPORADIC_PATTERN = 0;

	/**
	 * The number of structural features of the '<em>CH Sporadic Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CH_SPORADIC_PATTERN_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_PeriodicPatternImpl <em>CH Periodic Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_PeriodicPatternImpl
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getCH_PeriodicPattern()
	 * @generated
	 */
	int CH_PERIODIC_PATTERN = 1;

	/**
	 * The number of structural features of the '<em>CH Periodic Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CH_PERIODIC_PATTERN_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_BurstPatternImpl <em>CH Burst Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_BurstPatternImpl
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getCH_BurstPattern()
	 * @generated
	 */
	int CH_BURST_PATTERN = 2;

	/**
	 * The number of structural features of the '<em>CH Burst Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CH_BURST_PATTERN_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_PatternImpl <em>TA Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_PatternImpl
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getTA_Pattern()
	 * @generated
	 */
	int TA_PATTERN = 3;

	/**
	 * The number of structural features of the '<em>TA Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TA_PATTERN_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_ArbitraryPatternImpl <em>TA Arbitrary Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_ArbitraryPatternImpl
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getTA_ArbitraryPattern()
	 * @generated
	 */
	int TA_ARBITRARY_PATTERN = 4;

	/**
	 * The number of structural features of the '<em>TA Arbitrary Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TA_ARBITRARY_PATTERN_FEATURE_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.CH_SporadicPattern <em>CH Sporadic Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CH Sporadic Pattern</em>'.
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.CH_SporadicPattern
	 * @generated
	 */
	EClass getCH_SporadicPattern();

	/**
	 * Returns the meta object for class '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.CH_PeriodicPattern <em>CH Periodic Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CH Periodic Pattern</em>'.
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.CH_PeriodicPattern
	 * @generated
	 */
	EClass getCH_PeriodicPattern();

	/**
	 * Returns the meta object for class '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.CH_BurstPattern <em>CH Burst Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CH Burst Pattern</em>'.
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.CH_BurstPattern
	 * @generated
	 */
	EClass getCH_BurstPattern();

	/**
	 * Returns the meta object for class '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.TA_Pattern <em>TA Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>TA Pattern</em>'.
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.TA_Pattern
	 * @generated
	 */
	EClass getTA_Pattern();

	/**
	 * Returns the meta object for class '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.TA_ArbitraryPattern <em>TA Arbitrary Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>TA Arbitrary Pattern</em>'.
	 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.TA_ArbitraryPattern
	 * @generated
	 */
	EClass getTA_ArbitraryPattern();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RTDataTypesFactory getRTDataTypesFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_SporadicPatternImpl <em>CH Sporadic Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_SporadicPatternImpl
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getCH_SporadicPattern()
		 * @generated
		 */
		EClass CH_SPORADIC_PATTERN = eINSTANCE.getCH_SporadicPattern();

		/**
		 * The meta object literal for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_PeriodicPatternImpl <em>CH Periodic Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_PeriodicPatternImpl
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getCH_PeriodicPattern()
		 * @generated
		 */
		EClass CH_PERIODIC_PATTERN = eINSTANCE.getCH_PeriodicPattern();

		/**
		 * The meta object literal for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_BurstPatternImpl <em>CH Burst Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.CH_BurstPatternImpl
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getCH_BurstPattern()
		 * @generated
		 */
		EClass CH_BURST_PATTERN = eINSTANCE.getCH_BurstPattern();

		/**
		 * The meta object literal for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_PatternImpl <em>TA Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_PatternImpl
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getTA_Pattern()
		 * @generated
		 */
		EClass TA_PATTERN = eINSTANCE.getTA_Pattern();

		/**
		 * The meta object literal for the '{@link org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_ArbitraryPatternImpl <em>TA Arbitrary Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.TA_ArbitraryPatternImpl
		 * @see org.polarsys.chess.chessmlprofile.Predictability.RTComponentModel.RTDataTypes.impl.RTDataTypesPackageImpl#getTA_ArbitraryPattern()
		 * @generated
		 */
		EClass TA_ARBITRARY_PATTERN = eINSTANCE.getTA_ArbitraryPattern();

	}

} //RTDataTypesPackage
